%% This is file `DEMO-TUDaBeamer.tex' version 2.09 (2020/03/13),
%% it is part of
%% TUDa-CI -- Corporate Design for TU Darmstadt
%% ----------------------------------------------------------------------------
%%
%%  Copyright (C) 2018--2020 by Marei Peischl <marei@peitex.de>
%%
%% ============================================================================
%% This work may be distributed and/or modified under the
%% conditions of the LaTeX Project Public License, either version 1.3c
%% of this license or (at your option) any later version.
%% The latest version of this license is in
%% http://www.latex-project.org/lppl.txt
%% and version 1.3c or later is part of all distributions of LaTeX
%% version 2008/05/04 or later.
%%
%% This work has the LPPL maintenance status `maintained'.
%%
%% The Current Maintainers of this work are
%%   Marei Peischl <tuda-ci@peitex.de>
%%   Markus Lazanowski <latex@ce.tu-darmstadt.de>
%%
%% The development respository can be found at
%% https://github.com/tudace/tuda_latex_templates
%% Please use the issue tracker for feedback!
%%
%% ============================================================================
%%
% !TeX program = lualatex
%%

\documentclass[
	ngerman,%globale Übergabe der Hauptsprache
	aspectratio=169,%Beamer eigene Option zum Umschalten des Formates
	color={accentcolor=2d},
	logo=false,%Kein Logo auf Folgeseiten
	colorframetitle=false,%Akzentfarbe auch im Frametitle
%	logofile=example-image, %Falls die Logo Dateien nicht vorliegen
	]{tudabeamer}
\usepackage[main=ngerman]{babel}

% Der folgende Block ist nur bei pdfTeX auf Versionen vor April 2018 notwendig
\usepackage{iftex}
\ifPDFTeX
\usepackage[utf8]{inputenc}%kompatibilität mit TeX Versionen vor April 2018
\fi


%Makros für Formatierungen der Doku
%Im Allgemeinen nicht notwendig!
\let\code\texttt
\title{Blockchain Praktikum 2020
by Prof. Dr. Sebastian Faust}
\subtitle{ Integrating IoT in a Decentralized Renting Application}
\author[Alexander Lieb, Lennard Rüdesheim]{Alexander Lieb, Lennard Rüdesheim}
\department{FB 20}
\institute{Angewandte Kryptographie}

%Fremdlogo
%Logo Macro mit Sternchen skaliert automatisch, sodass das Logo in die Fußzeile passt
\logo*{\includegraphics{CAC-Logo-RGB_182_1}}

% Da das Bild frei wählbar nach Breite und/oder Höhe skaliert werden kann, werden \width/\height entsprechend gesetzt. So kann die Fläche optimal gefüllt werden.
%Sternchenversion skaliert automatisch und beschneidet das Bild, um die Fläche zu füllen.
%\titlegraphic*{\includegraphics{example-image}}
\date{\today}

\begin{document}

\maketitle

\setupTUDaFrame{logo=true}
\begin{frame}{Motivation}
~~Sharing economy  \includegraphics[scale=0.08]{Uber}\includegraphics[scale=0.1]{airbnb}
\begin{itemize}
	\item Shift from owning assets to shared access
	\item State of the art: centralized platforms
		\begin{itemize}
			\item Censorship %control access
			\item Lack of privacy
			\item Significant fees
		\end{itemize}
\end{itemize}

\end{frame}

\begin{frame}{Goals}

\begin{block}{Decentralised App (DAPP)}
	\begin{itemize}
		\item Avoid platform provider as a Trusted Third Party
		\item Example implementation: Rent-a-bike system
	\end{itemize}
\end{block}

\begin{block}{Integration of IoT device}
	\begin{itemize}
		\item Reduce risk and effort for the bike owner
			\begin{itemize}
				\item GPS tracking
				\item Automatic bike lock
				\item No need for action of the bike owner %after offering
			\end{itemize}
	\end{itemize}
\end{block}
\end{frame}

\begin{frame}{Goals}
	
\begin{block}{Reducing gas costs (optional)}
	\begin{itemize}
		\item Reducing needed interactions with the blockchain
		\item Using additional channel / Perun
	\end{itemize}
\end{block}
\end{frame}


\begin{frame}{Background}
  \begin{itemize}
  \item Several decentralized renting systems are already implemented
  \end{itemize}

  \begin{columns}
    \begin{column}{0.48\textwidth}
        \begin{block}{Bogner et al.}
          \begin{itemize}
          \item Android App
          \item for each product the owner posts a contract
          \item customer scans the QR code to find the contract
          \end{itemize}
        \end{block}
    \end{column}
    \begin{column}{0.48\textwidth}
      \begin{block}{Niya et al.}
        \begin{itemize}
        \item Android App
        \item Each user has to register with real data
        \item legally valid contracts
        \item transaction cost calculation 
        \end{itemize}
\vspace{0.31cm}
      \end{block}
    \end{column}
\end{columns}
  \vspace{0.3cm}
  \begin{center}
  \item $\Rightarrow $ but none of them uses the IoT functionality
  \end{center}
\end{frame}

\begin{frame}{Background}

  \begin{itemize}
  \item Several IoT architectures available (Pustišeka et al.)
    \begin{itemize}
    \item IoT blockchain application consists of two parts: On-Chain and Front-End
    \item On-Chain part is, where the contracts live
    \item Front-End is, where the IoT interacts. There are four possible front-end architectures:
      \begin{itemize}
      \item Stand-alone %RPI runs a node
      \item Server runs node with key storage, IoT device connects through web3.js
      \item Server runs node, IoT device has the key storage and connects through web3.js $\leftarrow$ our favourite
      \item proprietary communication protocol between server and IoT device
      \end{itemize}                    
    \end{itemize}
  \end{itemize}

\end{frame}


\begin{frame}{Project management concept}
Goal: iterative and flexible process % to react to problems during the project like for example the LTE stick might not working as expected, bike lock makes or problems or gas costs are to high
\begin{block}{Management Methodology} %based on Scrum and adapted to a two person team
	\begin{itemize}
		\item Divide project into sprint (2 weeks)
		\item User Stories to describe features %written from the perspective of an end user and contains an acceptance criteria to make it measurable whether a User Story is finished or not
		\item Store User Stories in an Product Backlog %to have an overview over all features
		\item Sprint planing meeting: move User Stories to the Sprint Backlog
		\item Sprint review meeting;
			\begin{itemize}
				\item Check if User Stories are completed 
				\item Code Review %for newly added code 
				\item Burndown Charts of the milestones % to know how much work remaining 
				\item Feedback about Software Engineering Process (five minutes) %The last sprint is evaluated and improvements for the next sprint are discussed
			\end{itemize}
	\end{itemize}
\end{block}
\end{frame}

\begin{frame}{Project management concept}
Using GitLab Issue boards for maintaining the User Stories and creating the Burndown charts
\includegraphics[scale=0.4]{gitlab_board}

\end{frame}
	
\begin{frame}{Project Plan}
\begin{block}{Milestones} 
%three main milestones
	\begin{itemize}
		\item Working renting system %By that we mean that when an user posts an bike to the system an contract is deployed to the blockchain, the contract is registered in the system and it possible to rent and reclaim a bike through it. 
		\begin{itemize}
			\item Possible to post a bike to the system
			\item Renting and reclaiming the bike through the contract
			\end{itemize}

	\end{itemize}
\end{block}
\end{frame}


\begin{frame}{Project Plan}
\begin{block}{Milestones}
%three main milestones
	\begin{itemize}
		\item Working renting system %By that we mean that when an user posts an bike to the system an contract is deployed to the blockchain, the contract is registered in the system and it possible to rent and reclaim a bike through it. 
		\begin{itemize}
			\item Possible to post a bike to the system
			\item Renting and reclaiming the bike through the contract
			\end{itemize}
		\item Working IoT device  %IoT device is able to show GPS information to a connected user, to get a connection to the internet via LTE stick and is able to open and close the lock.
			\begin{itemize}
				\item Connection to the internet via LTE stick
				\item Shows GPS information to connected user
				\item Open and close the lock
			\end{itemize}
	\end{itemize}
\end{block}
\end{frame}


\begin{frame}{Project Plan}
\begin{block}{Milestones}
%three main milestones
	\begin{itemize}
		\item Working renting system %By that we mean that when an user posts an bike to the system an contract is deployed to the blockchain, the contract is registered in the system and it possible to rent and reclaim a bike through it. 
		\begin{itemize}
			\item Possible to post a bike to the system
			\item Renting and reclaiming the bike through the contract
			\end{itemize}
		\item Working IoT device  %IoT device is able to show GPS information to a connected user, to get a connection to the internet via LTE stick and is able to open and close the lock.
			\begin{itemize}
				\item Connection to the internet via LTE stick
				\item Shows GPS information to connected user
				\item Open and close the lock
			\end{itemize}
		\item Connection between IoT device and contract % so that the contract is able to open and close the lock and gets the location and the travel distance of the bike from the IoT device.
			\begin{itemize}
				\item 	contract is able to open and close the lock 	
				\item contract gets location from the IoT device
			\end{itemize}
	\end{itemize}
\end{block}
\end{frame}


\begin{frame}{Project Plan}
\begin{block}{Milestones}
%three main milestones
	\begin{itemize}
		\item Working renting system %By that we mean that when an user posts an bike to the system an contract is deployed to the blockchain, the contract is registered in the system and it possible to rent and reclaim a bike through it. 
{\color{red}(Sprint 1: 27.04-11.05)}
		\begin{itemize}
			\item Possible to post a bike to the system
			\item Renting and reclaiming the bike through the contract
			\end{itemize}
		\item Working IoT device  %IoT device is able to show GPS information to a connected user, to get a connection to the internet via LTE stick and is able to open and close the lock.
{\color{red}(Sprint 2: 11.05-25.05)}
			\begin{itemize}
				\item Connection to the internet via LTE stick
				\item Shows GPS information to connected user
				\item Open and close the lock
			\end{itemize}
		\item Connection between IoT device and contract % so that the contract is able to open and close the lock and gets the location and the travel distance of the bike from the IoT device.
{\color{red}(Sprint 3: 25.05-08.06)} 
			\begin{itemize}
				\item 	contract is able to open and close the lock 	
				\item contract gets location from the IoT device
			\end{itemize}
	\end{itemize}
\end{block}
\end{frame}

\begin{frame}{Tools and Software}
	
	\begin{itemize}
		\item Truffle framework %to build the DAPP With this framework we can write smart contracts with the Solidity programming language and test and deploy them to the blockchain.
			\begin{itemize}
				\item Deploy smart contracts to Ethereum
			\end{itemize}
		\item web3.js javascript library %To communicate between the client-side application and the Ethereum client
			\begin{itemize}
				\item communication between client-side application and the Ethereum node
			\end{itemize}
	\end{itemize}
\end{frame}


\begin{frame}{Motivation for the management methodology}
	
	\begin{itemize}
		\item repeatedly inspection of the working software after each sprint possible
		\item easily integrate new requirements %by adding new User Stories into the Product Backlog
		\item recognize time problems early %through Burndown charts
	\end{itemize}
\end{frame}



\begin{frame}
\vspace{2cm}
\center \textbf{Thanks for listening!}
\end{frame}

\end{document}

